/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IAuthorsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Author details
        /// </summary>
        /// <remarks>
        /// View author details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="authorId">Author unique identifier</param>
        /// <returns>AuthorComplete</returns>
        AuthorComplete PrivateAuthorDetails (long? authorId);

        /// <summary>
        /// Author details
        /// </summary>
        /// <remarks>
        /// View author details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="authorId">Author unique identifier</param>
        /// <returns>ApiResponse of AuthorComplete</returns>
        ApiResponse<AuthorComplete> PrivateAuthorDetailsWithHttpInfo (long? authorId);
        /// <summary>
        /// Search Authors
        /// </summary>
        /// <remarks>
        /// Search for authors
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>List&lt;Author&gt;</returns>
        List<Author> PrivateAuthorsSearch (PrivateAuthorsSearch search = null);

        /// <summary>
        /// Search Authors
        /// </summary>
        /// <remarks>
        /// Search for authors
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>ApiResponse of List&lt;Author&gt;</returns>
        ApiResponse<List<Author>> PrivateAuthorsSearchWithHttpInfo (PrivateAuthorsSearch search = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Author details
        /// </summary>
        /// <remarks>
        /// View author details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="authorId">Author unique identifier</param>
        /// <returns>Task of AuthorComplete</returns>
        System.Threading.Tasks.Task<AuthorComplete> PrivateAuthorDetailsAsync (long? authorId);

        /// <summary>
        /// Author details
        /// </summary>
        /// <remarks>
        /// View author details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="authorId">Author unique identifier</param>
        /// <returns>Task of ApiResponse (AuthorComplete)</returns>
        System.Threading.Tasks.Task<ApiResponse<AuthorComplete>> PrivateAuthorDetailsAsyncWithHttpInfo (long? authorId);
        /// <summary>
        /// Search Authors
        /// </summary>
        /// <remarks>
        /// Search for authors
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of List&lt;Author&gt;</returns>
        System.Threading.Tasks.Task<List<Author>> PrivateAuthorsSearchAsync (PrivateAuthorsSearch search = null);

        /// <summary>
        /// Search Authors
        /// </summary>
        /// <remarks>
        /// Search for authors
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Author&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Author>>> PrivateAuthorsSearchAsyncWithHttpInfo (PrivateAuthorsSearch search = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class AuthorsApi : IAuthorsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="AuthorsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public AuthorsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="AuthorsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public AuthorsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Author details View author details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="authorId">Author unique identifier</param>
        /// <returns>AuthorComplete</returns>
        public AuthorComplete PrivateAuthorDetails (long? authorId)
        {
             ApiResponse<AuthorComplete> localVarResponse = PrivateAuthorDetailsWithHttpInfo(authorId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Author details View author details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="authorId">Author unique identifier</param>
        /// <returns>ApiResponse of AuthorComplete</returns>
        public ApiResponse< AuthorComplete > PrivateAuthorDetailsWithHttpInfo (long? authorId)
        {
            // verify the required parameter 'authorId' is set
            if (authorId == null)
                throw new ApiException(400, "Missing required parameter 'authorId' when calling AuthorsApi->PrivateAuthorDetails");

            var localVarPath = "/account/authors/{author_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (authorId != null) localVarPathParams.Add("author_id", this.Configuration.ApiClient.ParameterToString(authorId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateAuthorDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AuthorComplete>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AuthorComplete) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(AuthorComplete)));
        }

        /// <summary>
        /// Author details View author details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="authorId">Author unique identifier</param>
        /// <returns>Task of AuthorComplete</returns>
        public async System.Threading.Tasks.Task<AuthorComplete> PrivateAuthorDetailsAsync (long? authorId)
        {
             ApiResponse<AuthorComplete> localVarResponse = await PrivateAuthorDetailsAsyncWithHttpInfo(authorId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Author details View author details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="authorId">Author unique identifier</param>
        /// <returns>Task of ApiResponse (AuthorComplete)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AuthorComplete>> PrivateAuthorDetailsAsyncWithHttpInfo (long? authorId)
        {
            // verify the required parameter 'authorId' is set
            if (authorId == null)
                throw new ApiException(400, "Missing required parameter 'authorId' when calling AuthorsApi->PrivateAuthorDetails");

            var localVarPath = "/account/authors/{author_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (authorId != null) localVarPathParams.Add("author_id", this.Configuration.ApiClient.ParameterToString(authorId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateAuthorDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AuthorComplete>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AuthorComplete) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(AuthorComplete)));
        }

        /// <summary>
        /// Search Authors Search for authors
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>List&lt;Author&gt;</returns>
        public List<Author> PrivateAuthorsSearch (PrivateAuthorsSearch search = null)
        {
             ApiResponse<List<Author>> localVarResponse = PrivateAuthorsSearchWithHttpInfo(search);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Search Authors Search for authors
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>ApiResponse of List&lt;Author&gt;</returns>
        public ApiResponse< List<Author> > PrivateAuthorsSearchWithHttpInfo (PrivateAuthorsSearch search = null)
        {

            var localVarPath = "/account/authors/search";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (search != null && search.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(search); // http body (model) parameter
            }
            else
            {
                localVarPostBody = search; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateAuthorsSearch", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Author>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Author>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Author>)));
        }

        /// <summary>
        /// Search Authors Search for authors
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of List&lt;Author&gt;</returns>
        public async System.Threading.Tasks.Task<List<Author>> PrivateAuthorsSearchAsync (PrivateAuthorsSearch search = null)
        {
             ApiResponse<List<Author>> localVarResponse = await PrivateAuthorsSearchAsyncWithHttpInfo(search);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Search Authors Search for authors
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Author&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Author>>> PrivateAuthorsSearchAsyncWithHttpInfo (PrivateAuthorsSearch search = null)
        {

            var localVarPath = "/account/authors/search";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (search != null && search.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(search); // http body (model) parameter
            }
            else
            {
                localVarPostBody = search; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateAuthorsSearch", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Author>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Author>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Author>)));
        }

    }
}
