/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ArticleDOI
    /// </summary>
    [DataContract]
    public partial class ArticleDOI :  IEquatable<ArticleDOI>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticleDOI" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ArticleDOI() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticleDOI" /> class.
        /// </summary>
        /// <param name="doi">Reserved DOI (required).</param>
        public ArticleDOI(string doi = default(string))
        {
            // to ensure "doi" is required (not null)
            if (doi == null)
            {
                throw new InvalidDataException("doi is a required property for ArticleDOI and cannot be null");
            }
            else
            {
                this.Doi = doi;
            }
        }
        
        /// <summary>
        /// Reserved DOI
        /// </summary>
        /// <value>Reserved DOI</value>
        [DataMember(Name="doi", EmitDefaultValue=false)]
        public string Doi { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ArticleDOI {\n");
            sb.Append("  Doi: ").Append(Doi).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ArticleDOI);
        }

        /// <summary>
        /// Returns true if ArticleDOI instances are equal
        /// </summary>
        /// <param name="input">Instance of ArticleDOI to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ArticleDOI input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Doi == input.Doi ||
                    (this.Doi != null &&
                    this.Doi.Equals(input.Doi))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Doi != null)
                    hashCode = hashCode * 59 + this.Doi.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
