/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ArticleWithProject
    /// </summary>
    [DataContract]
    public partial class ArticleWithProject : Article,  IEquatable<ArticleWithProject>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticleWithProject" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ArticleWithProject() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticleWithProject" /> class.
        /// </summary>
        /// <param name="id">Unique identifier for article (required).</param>
        /// <param name="title">Title of article (required).</param>
        /// <param name="doi">DOI (required).</param>
        /// <param name="handle">Handle (required).</param>
        /// <param name="url">Api endpoint for article (required).</param>
        /// <param name="urlPublicHtml">Public site endpoint for article (required).</param>
        /// <param name="urlPublicApi">Public Api endpoint for article (required).</param>
        /// <param name="urlPrivateHtml">Private site endpoint for article (required).</param>
        /// <param name="urlPrivateApi">Private Api endpoint for article (required).</param>
        /// <param name="timeline">Various timeline dates (required).</param>
        /// <param name="thumb">Thumbnail image (required).</param>
        /// <param name="definedType">Type of article identifier (required).</param>
        /// <param name="definedTypeName">Name of the article type identifier (required).</param>
        /// <param name="projectId">Project id for this article. (required) (default to 0).</param>
        public ArticleWithProject(long? id = default(long?), string title = default(string), string doi = default(string), string handle = default(string), string url = default(string), string urlPublicHtml = default(string), string urlPublicApi = default(string), string urlPrivateHtml = default(string), string urlPrivateApi = default(string), Timeline timeline = default(Timeline), string thumb = default(string), long? definedType = default(long?), string definedTypeName = default(string), long? projectId = 0) : base()
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            // to ensure "doi" is required (not null)
            if (doi == null)
            {
                throw new InvalidDataException("doi is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.Doi = doi;
            }
            // to ensure "handle" is required (not null)
            if (handle == null)
            {
                throw new InvalidDataException("handle is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.Handle = handle;
            }
            // to ensure "url" is required (not null)
            if (url == null)
            {
                throw new InvalidDataException("url is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.Url = url;
            }
            // to ensure "urlPublicHtml" is required (not null)
            if (urlPublicHtml == null)
            {
                throw new InvalidDataException("urlPublicHtml is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.UrlPublicHtml = urlPublicHtml;
            }
            // to ensure "urlPublicApi" is required (not null)
            if (urlPublicApi == null)
            {
                throw new InvalidDataException("urlPublicApi is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.UrlPublicApi = urlPublicApi;
            }
            // to ensure "urlPrivateHtml" is required (not null)
            if (urlPrivateHtml == null)
            {
                throw new InvalidDataException("urlPrivateHtml is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.UrlPrivateHtml = urlPrivateHtml;
            }
            // to ensure "urlPrivateApi" is required (not null)
            if (urlPrivateApi == null)
            {
                throw new InvalidDataException("urlPrivateApi is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.UrlPrivateApi = urlPrivateApi;
            }
            // to ensure "timeline" is required (not null)
            if (timeline == null)
            {
                throw new InvalidDataException("timeline is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.Timeline = timeline;
            }
            // to ensure "thumb" is required (not null)
            if (thumb == null)
            {
                throw new InvalidDataException("thumb is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.Thumb = thumb;
            }
            // to ensure "definedType" is required (not null)
            if (definedType == null)
            {
                throw new InvalidDataException("definedType is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.DefinedType = definedType;
            }
            // to ensure "definedTypeName" is required (not null)
            if (definedTypeName == null)
            {
                throw new InvalidDataException("definedTypeName is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.DefinedTypeName = definedTypeName;
            }
            // to ensure "projectId" is required (not null)
            if (projectId == null)
            {
                throw new InvalidDataException("projectId is a required property for ArticleWithProject and cannot be null");
            }
            else
            {
                this.ProjectId = projectId;
            }
        }
        
        /// <summary>
        /// Unique identifier for article
        /// </summary>
        /// <value>Unique identifier for article</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// Title of article
        /// </summary>
        /// <value>Title of article</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// DOI
        /// </summary>
        /// <value>DOI</value>
        [DataMember(Name="doi", EmitDefaultValue=false)]
        public string Doi { get; set; }

        /// <summary>
        /// Handle
        /// </summary>
        /// <value>Handle</value>
        [DataMember(Name="handle", EmitDefaultValue=false)]
        public string Handle { get; set; }

        /// <summary>
        /// Api endpoint for article
        /// </summary>
        /// <value>Api endpoint for article</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Public site endpoint for article
        /// </summary>
        /// <value>Public site endpoint for article</value>
        [DataMember(Name="url_public_html", EmitDefaultValue=false)]
        public string UrlPublicHtml { get; set; }

        /// <summary>
        /// Public Api endpoint for article
        /// </summary>
        /// <value>Public Api endpoint for article</value>
        [DataMember(Name="url_public_api", EmitDefaultValue=false)]
        public string UrlPublicApi { get; set; }

        /// <summary>
        /// Private site endpoint for article
        /// </summary>
        /// <value>Private site endpoint for article</value>
        [DataMember(Name="url_private_html", EmitDefaultValue=false)]
        public string UrlPrivateHtml { get; set; }

        /// <summary>
        /// Private Api endpoint for article
        /// </summary>
        /// <value>Private Api endpoint for article</value>
        [DataMember(Name="url_private_api", EmitDefaultValue=false)]
        public string UrlPrivateApi { get; set; }

        /// <summary>
        /// Various timeline dates
        /// </summary>
        /// <value>Various timeline dates</value>
        [DataMember(Name="timeline", EmitDefaultValue=false)]
        public Timeline Timeline { get; set; }

        /// <summary>
        /// Thumbnail image
        /// </summary>
        /// <value>Thumbnail image</value>
        [DataMember(Name="thumb", EmitDefaultValue=false)]
        public string Thumb { get; set; }

        /// <summary>
        /// Type of article identifier
        /// </summary>
        /// <value>Type of article identifier</value>
        [DataMember(Name="defined_type", EmitDefaultValue=false)]
        public long? DefinedType { get; set; }

        /// <summary>
        /// Name of the article type identifier
        /// </summary>
        /// <value>Name of the article type identifier</value>
        [DataMember(Name="defined_type_name", EmitDefaultValue=false)]
        public string DefinedTypeName { get; set; }

        /// <summary>
        /// Project id for this article.
        /// </summary>
        /// <value>Project id for this article.</value>
        [DataMember(Name="project_id", EmitDefaultValue=false)]
        public long? ProjectId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ArticleWithProject {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Doi: ").Append(Doi).Append("\n");
            sb.Append("  Handle: ").Append(Handle).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  UrlPublicHtml: ").Append(UrlPublicHtml).Append("\n");
            sb.Append("  UrlPublicApi: ").Append(UrlPublicApi).Append("\n");
            sb.Append("  UrlPrivateHtml: ").Append(UrlPrivateHtml).Append("\n");
            sb.Append("  UrlPrivateApi: ").Append(UrlPrivateApi).Append("\n");
            sb.Append("  Timeline: ").Append(Timeline).Append("\n");
            sb.Append("  Thumb: ").Append(Thumb).Append("\n");
            sb.Append("  DefinedType: ").Append(DefinedType).Append("\n");
            sb.Append("  DefinedTypeName: ").Append(DefinedTypeName).Append("\n");
            sb.Append("  ProjectId: ").Append(ProjectId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ArticleWithProject);
        }

        /// <summary>
        /// Returns true if ArticleWithProject instances are equal
        /// </summary>
        /// <param name="input">Instance of ArticleWithProject to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ArticleWithProject input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && base.Equals(input) && 
                (
                    this.Doi == input.Doi ||
                    (this.Doi != null &&
                    this.Doi.Equals(input.Doi))
                ) && base.Equals(input) && 
                (
                    this.Handle == input.Handle ||
                    (this.Handle != null &&
                    this.Handle.Equals(input.Handle))
                ) && base.Equals(input) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && base.Equals(input) && 
                (
                    this.UrlPublicHtml == input.UrlPublicHtml ||
                    (this.UrlPublicHtml != null &&
                    this.UrlPublicHtml.Equals(input.UrlPublicHtml))
                ) && base.Equals(input) && 
                (
                    this.UrlPublicApi == input.UrlPublicApi ||
                    (this.UrlPublicApi != null &&
                    this.UrlPublicApi.Equals(input.UrlPublicApi))
                ) && base.Equals(input) && 
                (
                    this.UrlPrivateHtml == input.UrlPrivateHtml ||
                    (this.UrlPrivateHtml != null &&
                    this.UrlPrivateHtml.Equals(input.UrlPrivateHtml))
                ) && base.Equals(input) && 
                (
                    this.UrlPrivateApi == input.UrlPrivateApi ||
                    (this.UrlPrivateApi != null &&
                    this.UrlPrivateApi.Equals(input.UrlPrivateApi))
                ) && base.Equals(input) && 
                (
                    this.Timeline == input.Timeline ||
                    (this.Timeline != null &&
                    this.Timeline.Equals(input.Timeline))
                ) && base.Equals(input) && 
                (
                    this.Thumb == input.Thumb ||
                    (this.Thumb != null &&
                    this.Thumb.Equals(input.Thumb))
                ) && base.Equals(input) && 
                (
                    this.DefinedType == input.DefinedType ||
                    (this.DefinedType != null &&
                    this.DefinedType.Equals(input.DefinedType))
                ) && base.Equals(input) && 
                (
                    this.DefinedTypeName == input.DefinedTypeName ||
                    (this.DefinedTypeName != null &&
                    this.DefinedTypeName.Equals(input.DefinedTypeName))
                ) && base.Equals(input) && 
                (
                    this.ProjectId == input.ProjectId ||
                    (this.ProjectId != null &&
                    this.ProjectId.Equals(input.ProjectId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Doi != null)
                    hashCode = hashCode * 59 + this.Doi.GetHashCode();
                if (this.Handle != null)
                    hashCode = hashCode * 59 + this.Handle.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.UrlPublicHtml != null)
                    hashCode = hashCode * 59 + this.UrlPublicHtml.GetHashCode();
                if (this.UrlPublicApi != null)
                    hashCode = hashCode * 59 + this.UrlPublicApi.GetHashCode();
                if (this.UrlPrivateHtml != null)
                    hashCode = hashCode * 59 + this.UrlPrivateHtml.GetHashCode();
                if (this.UrlPrivateApi != null)
                    hashCode = hashCode * 59 + this.UrlPrivateApi.GetHashCode();
                if (this.Timeline != null)
                    hashCode = hashCode * 59 + this.Timeline.GetHashCode();
                if (this.Thumb != null)
                    hashCode = hashCode * 59 + this.Thumb.GetHashCode();
                if (this.DefinedType != null)
                    hashCode = hashCode * 59 + this.DefinedType.GetHashCode();
                if (this.DefinedTypeName != null)
                    hashCode = hashCode * 59 + this.DefinedTypeName.GetHashCode();
                if (this.ProjectId != null)
                    hashCode = hashCode * 59 + this.ProjectId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
