/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CurationDetail
    /// </summary>
    [DataContract]
    public partial class CurationDetail : Curation,  IEquatable<CurationDetail>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CurationDetail" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CurationDetail() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CurationDetail" /> class.
        /// </summary>
        /// <param name="id">The review id (required).</param>
        /// <param name="groupId">The group in which the article is present. (required).</param>
        /// <param name="accountId">The ID of the account of the owner of the article of this review. (required).</param>
        /// <param name="assignedTo">The ID of the account to which this review is assigned. (required).</param>
        /// <param name="articleId">The ID of the article of this review. (required).</param>
        /// <param name="version">The Version number of the article in review. (required).</param>
        /// <param name="commentsCount">The number of comments in the review. (required).</param>
        /// <param name="createdDate">The creation date of the review. (required).</param>
        /// <param name="modifiedDate">The date the review has been modified. (required).</param>
        /// <param name="item">Article details (required).</param>
        public CurationDetail(long? id = default(long?), long? groupId = default(long?), long? accountId = default(long?), long? assignedTo = default(long?), long? articleId = default(long?), long? version = default(long?), long? commentsCount = default(long?), StatusEnum status = default(StatusEnum), string createdDate = default(string), string modifiedDate = default(string), ArticleComplete item = default(ArticleComplete)) : base(status)
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "groupId" is required (not null)
            if (groupId == null)
            {
                throw new InvalidDataException("groupId is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.GroupId = groupId;
            }
            // to ensure "accountId" is required (not null)
            if (accountId == null)
            {
                throw new InvalidDataException("accountId is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.AccountId = accountId;
            }
            // to ensure "assignedTo" is required (not null)
            if (assignedTo == null)
            {
                throw new InvalidDataException("assignedTo is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.AssignedTo = assignedTo;
            }
            // to ensure "articleId" is required (not null)
            if (articleId == null)
            {
                throw new InvalidDataException("articleId is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.ArticleId = articleId;
            }
            // to ensure "version" is required (not null)
            if (version == null)
            {
                throw new InvalidDataException("version is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.Version = version;
            }
            // to ensure "commentsCount" is required (not null)
            if (commentsCount == null)
            {
                throw new InvalidDataException("commentsCount is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.CommentsCount = commentsCount;
            }
            // to ensure "createdDate" is required (not null)
            if (createdDate == null)
            {
                throw new InvalidDataException("createdDate is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.CreatedDate = createdDate;
            }
            // to ensure "modifiedDate" is required (not null)
            if (modifiedDate == null)
            {
                throw new InvalidDataException("modifiedDate is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.ModifiedDate = modifiedDate;
            }
            // to ensure "item" is required (not null)
            if (item == null)
            {
                throw new InvalidDataException("item is a required property for CurationDetail and cannot be null");
            }
            else
            {
                this.Item = item;
            }
        }
        
        /// <summary>
        /// The review id
        /// </summary>
        /// <value>The review id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// The group in which the article is present.
        /// </summary>
        /// <value>The group in which the article is present.</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// The ID of the account of the owner of the article of this review.
        /// </summary>
        /// <value>The ID of the account of the owner of the article of this review.</value>
        [DataMember(Name="account_id", EmitDefaultValue=false)]
        public long? AccountId { get; set; }

        /// <summary>
        /// The ID of the account to which this review is assigned.
        /// </summary>
        /// <value>The ID of the account to which this review is assigned.</value>
        [DataMember(Name="assigned_to", EmitDefaultValue=false)]
        public long? AssignedTo { get; set; }

        /// <summary>
        /// The ID of the article of this review.
        /// </summary>
        /// <value>The ID of the article of this review.</value>
        [DataMember(Name="article_id", EmitDefaultValue=false)]
        public long? ArticleId { get; set; }

        /// <summary>
        /// The Version number of the article in review.
        /// </summary>
        /// <value>The Version number of the article in review.</value>
        [DataMember(Name="version", EmitDefaultValue=false)]
        public long? Version { get; set; }

        /// <summary>
        /// The number of comments in the review.
        /// </summary>
        /// <value>The number of comments in the review.</value>
        [DataMember(Name="comments_count", EmitDefaultValue=false)]
        public long? CommentsCount { get; set; }

        /// <summary>
        /// The creation date of the review.
        /// </summary>
        /// <value>The creation date of the review.</value>
        [DataMember(Name="created_date", EmitDefaultValue=false)]
        public string CreatedDate { get; set; }

        /// <summary>
        /// The date the review has been modified.
        /// </summary>
        /// <value>The date the review has been modified.</value>
        [DataMember(Name="modified_date", EmitDefaultValue=false)]
        public string ModifiedDate { get; set; }

        /// <summary>
        /// Article details
        /// </summary>
        /// <value>Article details</value>
        [DataMember(Name="item", EmitDefaultValue=false)]
        public ArticleComplete Item { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CurationDetail {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  AccountId: ").Append(AccountId).Append("\n");
            sb.Append("  AssignedTo: ").Append(AssignedTo).Append("\n");
            sb.Append("  ArticleId: ").Append(ArticleId).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("  CommentsCount: ").Append(CommentsCount).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  ModifiedDate: ").Append(ModifiedDate).Append("\n");
            sb.Append("  Item: ").Append(Item).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CurationDetail);
        }

        /// <summary>
        /// Returns true if CurationDetail instances are equal
        /// </summary>
        /// <param name="input">Instance of CurationDetail to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CurationDetail input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && base.Equals(input) && 
                (
                    this.AccountId == input.AccountId ||
                    (this.AccountId != null &&
                    this.AccountId.Equals(input.AccountId))
                ) && base.Equals(input) && 
                (
                    this.AssignedTo == input.AssignedTo ||
                    (this.AssignedTo != null &&
                    this.AssignedTo.Equals(input.AssignedTo))
                ) && base.Equals(input) && 
                (
                    this.ArticleId == input.ArticleId ||
                    (this.ArticleId != null &&
                    this.ArticleId.Equals(input.ArticleId))
                ) && base.Equals(input) && 
                (
                    this.Version == input.Version ||
                    (this.Version != null &&
                    this.Version.Equals(input.Version))
                ) && base.Equals(input) && 
                (
                    this.CommentsCount == input.CommentsCount ||
                    (this.CommentsCount != null &&
                    this.CommentsCount.Equals(input.CommentsCount))
                ) && base.Equals(input) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && base.Equals(input) && 
                (
                    this.ModifiedDate == input.ModifiedDate ||
                    (this.ModifiedDate != null &&
                    this.ModifiedDate.Equals(input.ModifiedDate))
                ) && base.Equals(input) && 
                (
                    this.Item == input.Item ||
                    (this.Item != null &&
                    this.Item.Equals(input.Item))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.AccountId != null)
                    hashCode = hashCode * 59 + this.AccountId.GetHashCode();
                if (this.AssignedTo != null)
                    hashCode = hashCode * 59 + this.AssignedTo.GetHashCode();
                if (this.ArticleId != null)
                    hashCode = hashCode * 59 + this.ArticleId.GetHashCode();
                if (this.Version != null)
                    hashCode = hashCode * 59 + this.Version.GetHashCode();
                if (this.CommentsCount != null)
                    hashCode = hashCode * 59 + this.CommentsCount.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.ModifiedDate != null)
                    hashCode = hashCode * 59 + this.ModifiedDate.GetHashCode();
                if (this.Item != null)
                    hashCode = hashCode * 59 + this.Item.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
