/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// FundingSearch
    /// </summary>
    [DataContract]
    public partial class FundingSearch :  IEquatable<FundingSearch>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FundingSearch" /> class.
        /// </summary>
        /// <param name="searchFor">Search term.</param>
        public FundingSearch(string searchFor = default(string))
        {
            this.SearchFor = searchFor;
        }
        
        /// <summary>
        /// Search term
        /// </summary>
        /// <value>Search term</value>
        [DataMember(Name="search_for", EmitDefaultValue=false)]
        public string SearchFor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FundingSearch {\n");
            sb.Append("  SearchFor: ").Append(SearchFor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as FundingSearch);
        }

        /// <summary>
        /// Returns true if FundingSearch instances are equal
        /// </summary>
        /// <param name="input">Instance of FundingSearch to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FundingSearch input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.SearchFor == input.SearchFor ||
                    (this.SearchFor != null &&
                    this.SearchFor.Equals(input.SearchFor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SearchFor != null)
                    hashCode = hashCode * 59 + this.SearchFor.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
