/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ItemType
    /// </summary>
    [DataContract]
    public partial class ItemType :  IEquatable<ItemType>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ItemType" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ItemType() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ItemType" /> class.
        /// </summary>
        /// <param name="id">The ID of the item type. (required).</param>
        /// <param name="name">The name of the item type (required).</param>
        /// <param name="stringId">The string identifier of the item type. (required).</param>
        /// <param name="icon">The string identifying the icon of the item type. (required).</param>
        /// <param name="publicDescription">The description of the item type. (required).</param>
        /// <param name="isSelectable">The selectable status (required).</param>
        /// <param name="urlName">The URL name of the item type. (required).</param>
        public ItemType(long? id = default(long?), string name = default(string), string stringId = default(string), string icon = default(string), string publicDescription = default(string), bool? isSelectable = default(bool?), string urlName = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for ItemType and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new InvalidDataException("name is a required property for ItemType and cannot be null");
            }
            else
            {
                this.Name = name;
            }
            // to ensure "stringId" is required (not null)
            if (stringId == null)
            {
                throw new InvalidDataException("stringId is a required property for ItemType and cannot be null");
            }
            else
            {
                this.StringId = stringId;
            }
            // to ensure "icon" is required (not null)
            if (icon == null)
            {
                throw new InvalidDataException("icon is a required property for ItemType and cannot be null");
            }
            else
            {
                this.Icon = icon;
            }
            // to ensure "publicDescription" is required (not null)
            if (publicDescription == null)
            {
                throw new InvalidDataException("publicDescription is a required property for ItemType and cannot be null");
            }
            else
            {
                this.PublicDescription = publicDescription;
            }
            // to ensure "isSelectable" is required (not null)
            if (isSelectable == null)
            {
                throw new InvalidDataException("isSelectable is a required property for ItemType and cannot be null");
            }
            else
            {
                this.IsSelectable = isSelectable;
            }
            // to ensure "urlName" is required (not null)
            if (urlName == null)
            {
                throw new InvalidDataException("urlName is a required property for ItemType and cannot be null");
            }
            else
            {
                this.UrlName = urlName;
            }
        }
        
        /// <summary>
        /// The ID of the item type.
        /// </summary>
        /// <value>The ID of the item type.</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// The name of the item type
        /// </summary>
        /// <value>The name of the item type</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// The string identifier of the item type.
        /// </summary>
        /// <value>The string identifier of the item type.</value>
        [DataMember(Name="string_id", EmitDefaultValue=false)]
        public string StringId { get; set; }

        /// <summary>
        /// The string identifying the icon of the item type.
        /// </summary>
        /// <value>The string identifying the icon of the item type.</value>
        [DataMember(Name="icon", EmitDefaultValue=false)]
        public string Icon { get; set; }

        /// <summary>
        /// The description of the item type.
        /// </summary>
        /// <value>The description of the item type.</value>
        [DataMember(Name="public_description", EmitDefaultValue=false)]
        public string PublicDescription { get; set; }

        /// <summary>
        /// The selectable status
        /// </summary>
        /// <value>The selectable status</value>
        [DataMember(Name="is_selectable", EmitDefaultValue=false)]
        public bool? IsSelectable { get; set; }

        /// <summary>
        /// The URL name of the item type.
        /// </summary>
        /// <value>The URL name of the item type.</value>
        [DataMember(Name="url_name", EmitDefaultValue=false)]
        public string UrlName { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ItemType {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  StringId: ").Append(StringId).Append("\n");
            sb.Append("  Icon: ").Append(Icon).Append("\n");
            sb.Append("  PublicDescription: ").Append(PublicDescription).Append("\n");
            sb.Append("  IsSelectable: ").Append(IsSelectable).Append("\n");
            sb.Append("  UrlName: ").Append(UrlName).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ItemType);
        }

        /// <summary>
        /// Returns true if ItemType instances are equal
        /// </summary>
        /// <param name="input">Instance of ItemType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ItemType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.StringId == input.StringId ||
                    (this.StringId != null &&
                    this.StringId.Equals(input.StringId))
                ) && 
                (
                    this.Icon == input.Icon ||
                    (this.Icon != null &&
                    this.Icon.Equals(input.Icon))
                ) && 
                (
                    this.PublicDescription == input.PublicDescription ||
                    (this.PublicDescription != null &&
                    this.PublicDescription.Equals(input.PublicDescription))
                ) && 
                (
                    this.IsSelectable == input.IsSelectable ||
                    (this.IsSelectable != null &&
                    this.IsSelectable.Equals(input.IsSelectable))
                ) && 
                (
                    this.UrlName == input.UrlName ||
                    (this.UrlName != null &&
                    this.UrlName.Equals(input.UrlName))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.StringId != null)
                    hashCode = hashCode * 59 + this.StringId.GetHashCode();
                if (this.Icon != null)
                    hashCode = hashCode * 59 + this.Icon.GetHashCode();
                if (this.PublicDescription != null)
                    hashCode = hashCode * 59 + this.PublicDescription.GetHashCode();
                if (this.IsSelectable != null)
                    hashCode = hashCode * 59 + this.IsSelectable.GetHashCode();
                if (this.UrlName != null)
                    hashCode = hashCode * 59 + this.UrlName.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Id (long?) minimum
            if(this.Id < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Id, must be a value greater than or equal to 1.", new [] { "Id" });
            }

            yield break;
        }
    }

}
