/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectNote
    /// </summary>
    [DataContract]
    public partial class ProjectNote :  IEquatable<ProjectNote>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectNote" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectNote() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectNote" /> class.
        /// </summary>
        /// <param name="id">Project note id (required).</param>
        /// <param name="userId">User who wrote the note (required).</param>
        /// <param name="_abstract">Note Abstract - short/truncated content (required).</param>
        /// <param name="userName">Username of the one who wrote the note (required).</param>
        /// <param name="createdDate">Date when note was created (required).</param>
        /// <param name="modifiedDate">Date when note was last modified (required).</param>
        public ProjectNote(long? id = default(long?), long? userId = default(long?), string _abstract = default(string), string userName = default(string), string createdDate = default(string), string modifiedDate = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for ProjectNote and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "userId" is required (not null)
            if (userId == null)
            {
                throw new InvalidDataException("userId is a required property for ProjectNote and cannot be null");
            }
            else
            {
                this.UserId = userId;
            }
            // to ensure "_abstract" is required (not null)
            if (_abstract == null)
            {
                throw new InvalidDataException("_abstract is a required property for ProjectNote and cannot be null");
            }
            else
            {
                this.Abstract = _abstract;
            }
            // to ensure "userName" is required (not null)
            if (userName == null)
            {
                throw new InvalidDataException("userName is a required property for ProjectNote and cannot be null");
            }
            else
            {
                this.UserName = userName;
            }
            // to ensure "createdDate" is required (not null)
            if (createdDate == null)
            {
                throw new InvalidDataException("createdDate is a required property for ProjectNote and cannot be null");
            }
            else
            {
                this.CreatedDate = createdDate;
            }
            // to ensure "modifiedDate" is required (not null)
            if (modifiedDate == null)
            {
                throw new InvalidDataException("modifiedDate is a required property for ProjectNote and cannot be null");
            }
            else
            {
                this.ModifiedDate = modifiedDate;
            }
        }
        
        /// <summary>
        /// Project note id
        /// </summary>
        /// <value>Project note id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// User who wrote the note
        /// </summary>
        /// <value>User who wrote the note</value>
        [DataMember(Name="user_id", EmitDefaultValue=false)]
        public long? UserId { get; set; }

        /// <summary>
        /// Note Abstract - short/truncated content
        /// </summary>
        /// <value>Note Abstract - short/truncated content</value>
        [DataMember(Name="abstract", EmitDefaultValue=false)]
        public string Abstract { get; set; }

        /// <summary>
        /// Username of the one who wrote the note
        /// </summary>
        /// <value>Username of the one who wrote the note</value>
        [DataMember(Name="user_name", EmitDefaultValue=false)]
        public string UserName { get; set; }

        /// <summary>
        /// Date when note was created
        /// </summary>
        /// <value>Date when note was created</value>
        [DataMember(Name="created_date", EmitDefaultValue=false)]
        public string CreatedDate { get; set; }

        /// <summary>
        /// Date when note was last modified
        /// </summary>
        /// <value>Date when note was last modified</value>
        [DataMember(Name="modified_date", EmitDefaultValue=false)]
        public string ModifiedDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectNote {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  UserId: ").Append(UserId).Append("\n");
            sb.Append("  Abstract: ").Append(Abstract).Append("\n");
            sb.Append("  UserName: ").Append(UserName).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  ModifiedDate: ").Append(ModifiedDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectNote);
        }

        /// <summary>
        /// Returns true if ProjectNote instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectNote to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectNote input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.UserId == input.UserId ||
                    (this.UserId != null &&
                    this.UserId.Equals(input.UserId))
                ) && 
                (
                    this.Abstract == input.Abstract ||
                    (this.Abstract != null &&
                    this.Abstract.Equals(input.Abstract))
                ) && 
                (
                    this.UserName == input.UserName ||
                    (this.UserName != null &&
                    this.UserName.Equals(input.UserName))
                ) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && 
                (
                    this.ModifiedDate == input.ModifiedDate ||
                    (this.ModifiedDate != null &&
                    this.ModifiedDate.Equals(input.ModifiedDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.UserId != null)
                    hashCode = hashCode * 59 + this.UserId.GetHashCode();
                if (this.Abstract != null)
                    hashCode = hashCode * 59 + this.Abstract.GetHashCode();
                if (this.UserName != null)
                    hashCode = hashCode * 59 + this.UserName.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.ModifiedDate != null)
                    hashCode = hashCode * 59 + this.ModifiedDate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
