/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectPrivate
    /// </summary>
    [DataContract]
    public partial class ProjectPrivate : Project,  IEquatable<ProjectPrivate>, IValidatableObject
    {
        /// <summary>
        /// Role inside this project
        /// </summary>
        /// <value>Role inside this project</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum RoleEnum
        {
            
            /// <summary>
            /// Enum Owner for value: Owner
            /// </summary>
            [EnumMember(Value = "Owner")]
            Owner = 1,
            
            /// <summary>
            /// Enum Collaborator for value: Collaborator
            /// </summary>
            [EnumMember(Value = "Collaborator")]
            Collaborator = 2,
            
            /// <summary>
            /// Enum Viewer for value: Viewer
            /// </summary>
            [EnumMember(Value = "Viewer")]
            Viewer = 3
        }

        /// <summary>
        /// Role inside this project
        /// </summary>
        /// <value>Role inside this project</value>
        [DataMember(Name="role", EmitDefaultValue=false)]
        public RoleEnum Role { get; set; }
        /// <summary>
        /// Project storage type
        /// </summary>
        /// <value>Project storage type</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StorageEnum
        {
            
            /// <summary>
            /// Enum Individual for value: individual
            /// </summary>
            [EnumMember(Value = "individual")]
            Individual = 1,
            
            /// <summary>
            /// Enum Group for value: group
            /// </summary>
            [EnumMember(Value = "group")]
            Group = 2
        }

        /// <summary>
        /// Project storage type
        /// </summary>
        /// <value>Project storage type</value>
        [DataMember(Name="storage", EmitDefaultValue=false)]
        public StorageEnum Storage { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectPrivate" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectPrivate() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectPrivate" /> class.
        /// </summary>
        /// <param name="url">Api endpoint (required).</param>
        /// <param name="id">Project id (required).</param>
        /// <param name="title">Project title (required).</param>
        /// <param name="role">Role inside this project (required).</param>
        /// <param name="storage">Project storage type (required).</param>
        public ProjectPrivate(string url = default(string), long? id = default(long?), string title = default(string), RoleEnum role = default(RoleEnum), StorageEnum storage = default(StorageEnum)) : base()
        {
            // to ensure "url" is required (not null)
            if (url == null)
            {
                throw new InvalidDataException("url is a required property for ProjectPrivate and cannot be null");
            }
            else
            {
                this.Url = url;
            }
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for ProjectPrivate and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for ProjectPrivate and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            // to ensure "role" is required (not null)
            if (role == null)
            {
                throw new InvalidDataException("role is a required property for ProjectPrivate and cannot be null");
            }
            else
            {
                this.Role = role;
            }
            // to ensure "storage" is required (not null)
            if (storage == null)
            {
                throw new InvalidDataException("storage is a required property for ProjectPrivate and cannot be null");
            }
            else
            {
                this.Storage = storage;
            }
        }
        
        /// <summary>
        /// Api endpoint
        /// </summary>
        /// <value>Api endpoint</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Project id
        /// </summary>
        /// <value>Project id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// Project title
        /// </summary>
        /// <value>Project title</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }



        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectPrivate {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Role: ").Append(Role).Append("\n");
            sb.Append("  Storage: ").Append(Storage).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectPrivate);
        }

        /// <summary>
        /// Returns true if ProjectPrivate instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectPrivate to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectPrivate input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && base.Equals(input) && 
                (
                    this.Role == input.Role ||
                    (this.Role != null &&
                    this.Role.Equals(input.Role))
                ) && base.Equals(input) && 
                (
                    this.Storage == input.Storage ||
                    (this.Storage != null &&
                    this.Storage.Equals(input.Storage))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Role != null)
                    hashCode = hashCode * 59 + this.Role.GetHashCode();
                if (this.Storage != null)
                    hashCode = hashCode * 59 + this.Storage.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
