/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectsSearch
    /// </summary>
    [DataContract]
    public partial class ProjectsSearch : CommonSearch,  IEquatable<ProjectsSearch>, IValidatableObject
    {
        /// <summary>
        /// The field by which to order.
        /// </summary>
        /// <value>The field by which to order.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum OrderEnum
        {
            
            /// <summary>
            /// Enum Publisheddate for value: published_date
            /// </summary>
            [EnumMember(Value = "published_date")]
            Publisheddate = 1,
            
            /// <summary>
            /// Enum Modifieddate for value: modified_date
            /// </summary>
            [EnumMember(Value = "modified_date")]
            Modifieddate = 2,
            
            /// <summary>
            /// Enum Views for value: views
            /// </summary>
            [EnumMember(Value = "views")]
            Views = 3
        }

        /// <summary>
        /// The field by which to order.
        /// </summary>
        /// <value>The field by which to order.</value>
        [DataMember(Name="order", EmitDefaultValue=false)]
        public OrderEnum? Order { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsSearch" /> class.
        /// </summary>
        /// <param name="searchFor">Search term.</param>
        /// <param name="page">Page number. Used for pagination with page_size.</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (default to 10).</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query.</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit.</param>
        /// <param name="institution">only return collections from this institution.</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD.</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD.</param>
        /// <param name="group">only return collections from this group.</param>
        /// <param name="order">The field by which to order. (default to OrderEnum.Publisheddate).</param>
        public ProjectsSearch(string searchFor = default(string), long? page = default(long?), long? pageSize = 10, long? limit = default(long?), long? offset = default(long?), OrderDirectionEnum? orderDirection = desc, int? institution = default(int?), string publishedSince = default(string), string modifiedSince = default(string), int? group = default(int?), OrderEnum? order = OrderEnum.Publisheddate) : base(orderDirection)
        {
            this.SearchFor = searchFor;
            this.Page = page;
            // use default value if no "pageSize" provided
            if (pageSize == null)
            {
                this.PageSize = 10;
            }
            else
            {
                this.PageSize = pageSize;
            }
            this.Limit = limit;
            this.Offset = offset;
            this.Institution = institution;
            this.PublishedSince = publishedSince;
            this.ModifiedSince = modifiedSince;
            this.Group = group;
            // use default value if no "order" provided
            if (order == null)
            {
                this.Order = OrderEnum.Publisheddate;
            }
            else
            {
                this.Order = order;
            }
        }
        
        /// <summary>
        /// Search term
        /// </summary>
        /// <value>Search term</value>
        [DataMember(Name="search_for", EmitDefaultValue=false)]
        public string SearchFor { get; set; }

        /// <summary>
        /// Page number. Used for pagination with page_size
        /// </summary>
        /// <value>Page number. Used for pagination with page_size</value>
        [DataMember(Name="page", EmitDefaultValue=false)]
        public long? Page { get; set; }

        /// <summary>
        /// The number of results included on a page. Used for pagination with page
        /// </summary>
        /// <value>The number of results included on a page. Used for pagination with page</value>
        [DataMember(Name="page_size", EmitDefaultValue=false)]
        public long? PageSize { get; set; }

        /// <summary>
        /// Number of results included on a page. Used for pagination with query
        /// </summary>
        /// <value>Number of results included on a page. Used for pagination with query</value>
        [DataMember(Name="limit", EmitDefaultValue=false)]
        public long? Limit { get; set; }

        /// <summary>
        /// Where to start the listing(the offset of the first result). Used for pagination with limit
        /// </summary>
        /// <value>Where to start the listing(the offset of the first result). Used for pagination with limit</value>
        [DataMember(Name="offset", EmitDefaultValue=false)]
        public long? Offset { get; set; }

        /// <summary>
        /// only return collections from this institution
        /// </summary>
        /// <value>only return collections from this institution</value>
        [DataMember(Name="institution", EmitDefaultValue=false)]
        public int? Institution { get; set; }

        /// <summary>
        /// Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
        /// </summary>
        /// <value>Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD</value>
        [DataMember(Name="published_since", EmitDefaultValue=false)]
        public string PublishedSince { get; set; }

        /// <summary>
        /// Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
        /// </summary>
        /// <value>Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD</value>
        [DataMember(Name="modified_since", EmitDefaultValue=false)]
        public string ModifiedSince { get; set; }

        /// <summary>
        /// only return collections from this group
        /// </summary>
        /// <value>only return collections from this group</value>
        [DataMember(Name="group", EmitDefaultValue=false)]
        public int? Group { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectsSearch {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  SearchFor: ").Append(SearchFor).Append("\n");
            sb.Append("  Page: ").Append(Page).Append("\n");
            sb.Append("  PageSize: ").Append(PageSize).Append("\n");
            sb.Append("  Limit: ").Append(Limit).Append("\n");
            sb.Append("  Offset: ").Append(Offset).Append("\n");
            sb.Append("  Institution: ").Append(Institution).Append("\n");
            sb.Append("  PublishedSince: ").Append(PublishedSince).Append("\n");
            sb.Append("  ModifiedSince: ").Append(ModifiedSince).Append("\n");
            sb.Append("  Group: ").Append(Group).Append("\n");
            sb.Append("  Order: ").Append(Order).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectsSearch);
        }

        /// <summary>
        /// Returns true if ProjectsSearch instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectsSearch to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectsSearch input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.SearchFor == input.SearchFor ||
                    (this.SearchFor != null &&
                    this.SearchFor.Equals(input.SearchFor))
                ) && base.Equals(input) && 
                (
                    this.Page == input.Page ||
                    (this.Page != null &&
                    this.Page.Equals(input.Page))
                ) && base.Equals(input) && 
                (
                    this.PageSize == input.PageSize ||
                    (this.PageSize != null &&
                    this.PageSize.Equals(input.PageSize))
                ) && base.Equals(input) && 
                (
                    this.Limit == input.Limit ||
                    (this.Limit != null &&
                    this.Limit.Equals(input.Limit))
                ) && base.Equals(input) && 
                (
                    this.Offset == input.Offset ||
                    (this.Offset != null &&
                    this.Offset.Equals(input.Offset))
                ) && base.Equals(input) && 
                (
                    this.Institution == input.Institution ||
                    (this.Institution != null &&
                    this.Institution.Equals(input.Institution))
                ) && base.Equals(input) && 
                (
                    this.PublishedSince == input.PublishedSince ||
                    (this.PublishedSince != null &&
                    this.PublishedSince.Equals(input.PublishedSince))
                ) && base.Equals(input) && 
                (
                    this.ModifiedSince == input.ModifiedSince ||
                    (this.ModifiedSince != null &&
                    this.ModifiedSince.Equals(input.ModifiedSince))
                ) && base.Equals(input) && 
                (
                    this.Group == input.Group ||
                    (this.Group != null &&
                    this.Group.Equals(input.Group))
                ) && base.Equals(input) && 
                (
                    this.Order == input.Order ||
                    (this.Order != null &&
                    this.Order.Equals(input.Order))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.SearchFor != null)
                    hashCode = hashCode * 59 + this.SearchFor.GetHashCode();
                if (this.Page != null)
                    hashCode = hashCode * 59 + this.Page.GetHashCode();
                if (this.PageSize != null)
                    hashCode = hashCode * 59 + this.PageSize.GetHashCode();
                if (this.Limit != null)
                    hashCode = hashCode * 59 + this.Limit.GetHashCode();
                if (this.Offset != null)
                    hashCode = hashCode * 59 + this.Offset.GetHashCode();
                if (this.Institution != null)
                    hashCode = hashCode * 59 + this.Institution.GetHashCode();
                if (this.PublishedSince != null)
                    hashCode = hashCode * 59 + this.PublishedSince.GetHashCode();
                if (this.ModifiedSince != null)
                    hashCode = hashCode * 59 + this.ModifiedSince.GetHashCode();
                if (this.Group != null)
                    hashCode = hashCode * 59 + this.Group.GetHashCode();
                if (this.Order != null)
                    hashCode = hashCode * 59 + this.Order.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            // Page (long?) maximum
            if(this.Page > (long?)5000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Page, must be a value less than or equal to 5000.", new [] { "Page" });
            }

            // Page (long?) minimum
            if(this.Page < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Page, must be a value greater than or equal to 1.", new [] { "Page" });
            }

            // PageSize (long?) maximum
            if(this.PageSize > (long?)1000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PageSize, must be a value less than or equal to 1000.", new [] { "PageSize" });
            }

            // PageSize (long?) minimum
            if(this.PageSize < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PageSize, must be a value greater than or equal to 1.", new [] { "PageSize" });
            }

            // Limit (long?) maximum
            if(this.Limit > (long?)1000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Limit, must be a value less than or equal to 1000.", new [] { "Limit" });
            }

            // Limit (long?) minimum
            if(this.Limit < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Limit, must be a value greater than or equal to 1.", new [] { "Limit" });
            }

            // Offset (long?) maximum
            if(this.Offset > (long?)5000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Offset, must be a value less than or equal to 5000.", new [] { "Offset" });
            }

            // Offset (long?) minimum
            if(this.Offset < (long?)0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Offset, must be a value greater than or equal to 0.", new [] { "Offset" });
            }

            yield break;
        }
    }

}
